<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Map extends Controller_Handler {
		
        public function before() {
            $this->model = new Model_Teacher_Map;
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }
        
		private function privateDeleteSubmodule($SubmoduleID) {
			$result = $this->model->deleteSubmodule($this->user['TeacherID'], $SubmoduleID);
			return $result[0]['Num'];
		}
		
		// Добавление преподавателем дисциплины
		public function action_AddDiscipline() {
			$data['success'] = false;
            $this->post -> rule('Grade', 'not_empty')
                        -> rule('Grade', 'digit')
						-> rule('SubjectID', 'not_empty')
                        -> rule('SubjectID', 'digit')
						-> rule('ExamType', 'not_empty')
						-> rule('LectionCount', 'not_empty')
                        -> rule('LectionCount', 'digit')
						-> rule('PracticeCount', 'not_empty')
                        -> rule('PracticeCount', 'digit')
						-> rule('DepartmentID', 'not_empty')
                        -> rule('DepartmentID', 'digit');
            if($this->post->check()) {
					$result = $this->model->AddDiscipline(
						$this->user['TeacherID'],
						$this->post->offsetGet('Grade'),
						$this->post->offsetGet('SubjectID'),
						$this->post->offsetGet('ExamType'),
						$this->post->offsetGet('LectionCount'),
						$this->post->offsetGet('PracticeCount'),
						$this->post->offsetGet('DepartmentID')
					);
					$data['DisciplineID'] = $result[0]['Num'];
					if ($data['DisciplineID'] > 0)
						$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Изменения базовых параметров дисциплины
		public function action_ChangeDiscipline() {
			$data['success'] = false;
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit')
						-> rule('Grade', 'not_empty')
                        -> rule('Grade', 'digit')
						-> rule('SubjectID', 'not_empty')
                        -> rule('SubjectID', 'digit')
						-> rule('ExamType', 'not_empty')
						-> rule('LectionCount', 'not_empty')
                        -> rule('LectionCount', 'digit')
						-> rule('PracticeCount', 'not_empty')
                        -> rule('PracticeCount', 'digit');
            if($this->post->check()) {
					$result = $this->model->ChangeDiscipline(
						$this->user['TeacherID'],
						$this->post->offsetGet('DisciplineID'),
						$this->post->offsetGet('ExamType'),
						$this->post->offsetGet('LectionCount'),
						$this->post->offsetGet('PracticeCount'),
						$this->post->offsetGet('Grade'),
						$this->post->offsetGet('SubjectID')
					);
					if ($result[0]['Num'] == 0)
						$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Добавить модуль и к модулю 1 мероприятие
		public function action_AddModule(){
			$data['success'] = false;
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit')
						-> rule('OrderNum', 'not_empty')
                        -> rule('OrderNum', 'digit');
            if($this->post->check()) {
				// Добавление модуля
                $result = $this->model->AddModule(
					$this->user['TeacherID'],
					$this->post->offsetGet('DisciplineID'),
					$this->post->offsetGet('OrderNum'),
					'Наименование модуля'
				);
				$data['ModuleID'] = $result[0]['Num'];
				if ($data['ModuleID'] > 0) {
					// Добавление мероприятия
					// Т.к. модуль должен содержать хотя бы
					// 1 мероприятие
					$result = $this->model->AddSubmodule(
						$this->user['TeacherID'],
						$data['ModuleID'],
						'0', //MaxRate
						'1', //OrderNum
						'Наименование мероприятия',
						'', //Description
						'CurrentControl'
					);
					$data['SubmoduleID'] = $result[0]['Num'];
					if ($data['SubmoduleID'] > 0)
						$data['success'] = true;
				}
					
            }
			$this->response->body(json_encode($data));
		}
		
		// Добавление мероприятия
		public function action_AddSubmodule() {
			$data['success'] = false;
            $this->post -> rule('ModuleID', 'not_empty')
                        -> rule('ModuleID', 'digit')
						-> rule('OrderNum', 'not_empty')
                        -> rule('OrderNum', 'digit');
            if($this->post->check()) {
					$result = $this->model->AddSubmodule(
						$this->user['TeacherID'],
						$this->post->offsetGet('ModuleID'),
						'0', //MaxRate
						$this->post->offsetGet('OrderNum'),
						'Наименование мероприятия',
						'', //Description
						'CurrentControl'
					);
					$data['SubmoduleID'] = $result[0]['Num'];
					if ($data['SubmoduleID'] > 0)
						$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Поменять имя модуля
		public function action_ChangeModuleName() {
			$data['success'] = false;
            $this->post -> rule('ModuleID', 'not_empty')
                        -> rule('ModuleID', 'digit')
						-> rule('ModuleName', 'not_empty');
            if($this->post->check()) {
                $result = $this->model->ChangeModuleName($this->user['TeacherID'], $this->post->offsetGet('ModuleID'), $this->post->offsetGet('ModuleName'));
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Поменять имя мероприятия
		public function action_ChangeSubmoduleName() {
			$data['success'] = false;
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('SubmoduleName', 'not_empty');
            if($this->post->check()) {
                $result = $this->model->ChangeSubmoduleName($this->user['TeacherID'], $this->post->offsetGet('SubmoduleID'), $this->post->offsetGet('SubmoduleName'));
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
			$this->response->body(json_encode($data));
		}
		
		// СВАП порядка двух модулей
		public function action_SwapModuleOrder() {
			$data['success'] = false;
            $this->post -> rule('ModuleID1', 'not_empty')
                        -> rule('ModuleID1', 'digit')
						-> rule('ModuleID2', 'not_empty')
						-> rule('ModuleID2', 'digit');
            if($this->post->check()) {
				$result = $this->model->SwapModuleOrder(
					$this->user['TeacherID'],
					$this->post->offsetGet('ModuleID1'),
					$this->post->offsetGet('ModuleID2')
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Свап порядка двух мероприятий
		public function action_SwapSubmoduleOrder(){
			$data['success'] = false;
            $this->post -> rule('SubmoduleID1', 'not_empty')
                        -> rule('SubmoduleID1', 'digit')
						-> rule('SubmoduleID2', 'not_empty')
						-> rule('SubmoduleID2', 'digit');
            if($this->post->check()) {
				$result = $this->model->SwapSubmoduleOrder(
					$this->user['TeacherID'],
					$this->post->offsetGet('SubmoduleID1'),
					$this->post->offsetGet('SubmoduleID2')
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
            $this->response->body(json_encode($data));
		}
		
		// Удалить модуль и его мероприятия
		public function action_DeleteModule() {
			$data['success'] = false;
            $this->post -> rule('ModuleID', 'not_empty')
                        -> rule('ModuleID', 'digit')
						-> rule('SubmodulesID', 'not_empty')
						-> rule('CurrentModuleOrder', 'not_empty')
                        -> rule('CurrentModuleOrder', 'digit');
            if($this->post->check()) {
				$ChangeOrderModulesID = json_decode($this->post->offsetGet('ChangeOrderModulesID'));
				$Submodules = json_decode($this->post->offsetGet('SubmodulesID'));
				foreach ($Submodules as &$SubmoduleID) {
					$this->privateDeleteSubmodule($SubmoduleID);
				}
                $result = $this->model->deleteModule(
					$this->user['TeacherID'],
					$this->post->offsetGet('ModuleID')
				);
				if ($result[0]['Num'] == 0) {
					if (count($ChangeOrderModulesID) > 0) {
						$NewOrder = $this->post->offsetGet('CurrentModuleOrder');
						foreach($ChangeOrderModulesID as $ModuleID) {
							$this->model->ChangeModuleOrder(
								$this->user['TeacherID'],
								$ModuleID,
								$NewOrder
							);
							$NewOrder++;
						}
					}
					$data['success'] = true;
				}
            }
            $this->response->body(json_encode($data));
        }
		
		// Удалить мероприятие
		public function action_DeleteSubmodule() {
			$data['success'] = false;
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('CurrentSubmoduleOrder', 'not_empty')
                        -> rule('CurrentSubmoduleOrder', 'digit');
            if($this->post->check()) {
				$ChangeOrderSubmodulesID = json_decode($this->post->offsetGet('ChangeOrderSubmodulesID'));
                $result = $this->privateDeleteSubmodule($this->post->offsetGet('SubmoduleID'));
				if ($result == 0) {
					if (count($ChangeOrderSubmodulesID) > 0) {
						$NewOrder = $this->post->offsetGet('CurrentSubmoduleOrder');
						foreach($ChangeOrderSubmodulesID as $SubmoduleID) {
							$this->model->ChangeSubmoduleOrder(
								$this->user['TeacherID'],
								$SubmoduleID,
								$NewOrder
							);
							$NewOrder++;
						}
					}
					$data['success'] = true;
				}
			}
			$this->response->body(json_encode($data));
        }
		
		//  Изменение макс. балла подмодуля
		public function action_ChangeSubmoduleMaxRate() {
			$data['success'] = false;
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('MaxRate', 'not_empty');
            if($this->post->check()) {
                 $result = $this->model->ChangeSubmoduleMaxRate(
					$this->user['TeacherID'],
					$this->post->offsetGet('SubmoduleID'), 
					$this->post->offsetGet('MaxRate')
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
			$this->response->body(json_encode($data));
		}
		
		// Изменение типа подмодуля
		public function action_ChangeSubmoduleControlType() {
			$data['success'] = false;
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('ControlType', 'not_empty');
            if($this->post->check()) {
                 $result = $this->model->ChangeSubmoduleControlType(
					$this->user['TeacherID'],
					$this->post->offsetGet('SubmoduleID'), 
					$this->post->offsetGet('ControlType')
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;	
			}
			$this->response->body(json_encode($data));
		}
		
		public function action_ChangeSubmoduleDescription() {
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('Description', 'not_empty');
            if($this->post->check()) {
                //$this->model->ChangeSubmoduleDescription($this->user['TeacherID'], $this->post->offsetGet('SubmoduleID'), $this->post->offsetGet('Description'));
				$this->response->body(json_encode('Ok, ChangeSubmoduleDescription!'));
            }
            else
                $this->response->body(json_encode('Error, ChangeSubmoduleDescription'));
		}
}
